## ------------------------------------------------------------------- 
## 
## Copyright (c) "2014" Dmitri Zagidulin and Basho Technologies, Inc.
##
## This file is provided to you under the Apache License,
## Version 2.0 (the "License"); you may not use this file
## except in compliance with the License.  You may obtain
## a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
## -------------------------------------------------------------------

module Riagent
  # Generic Riagent exception class
  class RiagentError < StandardError
  end
  
  # Raised by <tt>save!</tt> when a document does not pass validation
  class InvalidDocumentError < RiagentError
    attr_reader :document # :nodoc:
    def initialize(document) # :nodoc:
      @document = document
    end
  end
end